Imports System.Data
Imports System.Data.SqlClient
Partial Class VB
    Inherits System.Web.UI.Page
    Private CurrentPage As Integer = 1
    Private ItemsPerPage As Integer = 4
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load
        If ViewState("CurrentPage") IsNot Nothing Then
            Me.CurrentPage = Convert.ToInt32(ViewState("CurrentPage"))
        End If
        If Not IsPostBack Then
            Dim TotalRows As Integer = Me.BindList(1)
            Me.Prepare_Pager(TotalRows)
        End If
    End Sub
    Protected Sub Pager_Click(ByVal sender As Object, ByVal e As EventArgs)
        Dim lnkPager As LinkButton = DirectCast(sender, LinkButton)
        Dim PageNo As Integer = 1
        Select Case lnkPager.CommandName
            Case "Previous"
                PageNo = Me.CurrentPage - 1
                Exit Select
            Case "Next"
                PageNo = Me.CurrentPage + 1
                Exit Select
        End Select
        Dim TotalRows As Integer = Me.BindList(PageNo)
        Dim PageCount As Integer = Me.CalculateTotalPages(TotalRows)
        ViewState("CurrentPage") = PageNo
        If PageNo = 1 Then
            lnkPrev.Enabled = False
        Else
            lnkPrev.Enabled = True
        End If
        If PageNo = PageCount Then
            lnkNext.Enabled = False
        Else
            lnkNext.Enabled = True
        End If
    End Sub

    Private Function BindList(ByVal PageNo As Integer) As Integer
        Dim TotalRows As Integer = 0
        Dim dt As New DataTable()
        Dim strConnString As [String] = System.Configuration _
            .ConfigurationManager.ConnectionStrings("conString").ConnectionString
        Dim con As New SqlConnection(strConnString)
        Dim sda As New SqlDataAdapter()
        Dim cmd As New SqlCommand("spx_Pager")
        cmd.CommandType = CommandType.StoredProcedure
        cmd.Parameters.Add("@PageNo", SqlDbType.Int).Value = PageNo
        cmd.Parameters.Add("@ItemsPerPage", SqlDbType.Int).Value = ItemsPerPage
        cmd.Parameters.Add("@TotalRows", SqlDbType.Int).Direction = ParameterDirection.Output
        cmd.Connection = con
        Try
            con.Open()
            sda.SelectCommand = cmd
            sda.Fill(dt)
            DataList1.DataSource = dt
            DataList1.DataBind()
            TotalRows = Convert.ToInt32(cmd.Parameters("@TotalRows").Value)
        Catch ex As Exception
            Response.Write(ex.Message)
        Finally
            con.Close()
            sda.Dispose()
            con.Dispose()
        End Try
        Return TotalRows
    End Function

    Private Sub Prepare_Pager(ByVal TotalRows As Integer)
        Dim intPageCount As Integer = Me.CalculateTotalPages(TotalRows)
        If intPageCount > 1 AndAlso Me.CurrentPage < intPageCount Then
            Me.lnkNext.Enabled = True
        End If
        If Me.CurrentPage <> 1 Then
            Me.lnkPrev.Enabled = True
        Else
            Me.lnkPrev.Enabled = False
        End If
    End Sub

    Private Function CalculateTotalPages(ByVal intTotalRows As Integer) As Integer
        Dim intPageCount As Integer = 1
        Dim dblPageCount As Double = CDbl((Convert.ToDecimal(intTotalRows) / Convert.ToDecimal(Me.ItemsPerPage)))
        intPageCount = Convert.ToInt32(Math.Ceiling(dblPageCount))
        Return intPageCount
    End Function
End Class
